# -*- coding: utf-8 -*-

#' # Aufgabe 4

# Standard imports
import numpy as np
import numpy.linalg as la

#%%
#' ## (a)

def invPot(A,eps):
    v = np.ones((A.shape[0],1))
    k = 0
    while True:
        k = k+1
        vt = la.solve(A,v)
        v = vt/la.norm(vt)
        mu = v.T@A@v
        if la.norm(A@v-mu*v) <= eps:
            print('Iterationen', k)
            break
        
    return v, mu
#%%
#' ## (b)

eps = 1e-5
A = np.diag([10]*19 + [1])

invPot(A,eps)

# Vergleich mit la.eig hat in der Vorlesung fehlt 
v, mu = invPot(A, eps)
muref, vref = la.eig(A)
ind = np.argmin(muref)
print(la.norm(v - vref[:,[ind]]/la.norm(vref[:,ind])))
print(abs(mu - muref[ind]))
#%%
#' ## Für Ihre Tests